<app-loading *ngIf="isLoading"></app-loading>
<div id='request-list' class="content__item content__item--border bg__content--default app-card">
  <form nz-form [formGroup]="form" scroll-spy>
    <div nz-row [nzGutter]="[30,30]">
      <div nz-col nzXs="24" nzLg="6">
        <mb-date-picker mbPlaceholderText="{{'selfService.label.fromTime' | translate}}"
          mbLabelText="{{'selfService.label.fromTime' | translate}}" formControlName="fromTime">
        </mb-date-picker>
      </div>
      <div nz-col nzXs="24" nzLg="6">
        <mb-date-picker mbPlaceholderText="{{'selfService.label.toTime' | translate}}"
          mbLabelText="{{'selfService.label.toTime' | translate}}" formControlName="toTime"
          [mbType]="isSubmitted && (form.controls['toTime'].errors || form.errors) ? 'error' : 'default'"
          [mbShowError]="isSubmitted && (form.controls['toTime'].errors || form.errors) != null"
          [mbErrors]="form.controls['toTime'].errors ? form.controls['toTime'].errors : ( form.errors ? form.errors : null)"
          [mbErrorDefs]="[
              { errorName: 'rangeDateError', errorDescription: 'selfService.validate.rangeDate.pareDateMore' | translate: {toDate: 'selfService.label.toTime' | translate, fromDate: 'selfService.label.fromTime' | translate}}
          ]"></mb-date-picker>
      </div>
      <!-- <div nz-col nzXs="24" nzLg="6">
        <mb-select [mbDataSelects]="LEAVE_TYPE_DATASOURCE"
          mbLabelText="{{'selfService.label.requestLeave' | translate}}" [mbOptionHeightPx]="56"
          [mbOptionOverflowSize]="2" mbPlaceholder="{{'selfService.label.requestLeave' | translate}}"
          [formControlName]="'leaveType'" [mbDisable]="true"></mb-select>
      </div> -->
      <div nz-col nzXs="24" nzLg="6">
        <mb-select-check-able
                    [mbShowAction]="false"
                    [mbDataSelects]="listReasonLeave"
                    formControlName="reasonLeaveId"
                    mbKeyLabel="name" mbKeyValue="reasonLeaveId"
                    mbPlaceholder="{{'selfService.label.reasonLeave' | translate }}"
                    mbLabelText="{{'selfService.label.reasonLeave' | translate}}"
                ></mb-select-check-able>        
      </div>
      <div nz-col nzXs="24" nzLg="6">
          <mb-select-check-able
            [mbShowAction]="false"
            [mbDataSelects]="REQUEST_STATUS_DATASOURCE"
            formControlName="listStatus"
            mbPlaceholder="{{'selfService.label.status' | translate }}"
            mbLabelText="{{'selfService.label.status' | translate}}">
          </mb-select-check-able>
      </div>
      <div nz-col nzXs="24" nzLg="24" class="text-center">
<!--        <mb-button-->
<!--          class='button__class&#45;&#45;no-padding button__class&#45;&#45;no-margin'-->
<!--          mbButtonType='NO_BORDER'-->
<!--          mbButtonSize='LARGE'-->
<!--          mbPrefixIcon='plus-circle'-->
<!--          mbButtonBgColor='transparent'-->
<!--          mbButtonText="{{'selfService.label.infoLeaveInYear' | translate}}"-->
<!--          (click)="onLeaveDetailModalClick()"-->
<!--        ></mb-button>-->
        <mb-button mbButtonSize='SMALL' mbButtonAvailableStyle='SEARCH' (click)='doSearch(1)'
                   mbButtonText="{{'selfService.label.search' | translate}}"></mb-button>
      </div>
    </div>
    <div nz-col nzXs='24' nzLg='24' >
      <div style='padding: 5px 15px;' class='btn-top-right'>
        <mb-button
          mbButtonSize='SMALL'
          mbButtonAvailableStyle='PRIMARY'
          mbButtonText="{{'selfService.label.infoLeaveInYear' | translate}}"
          (click)="onLeaveDetailModalClick()"
        ></mb-button>
            <mb-button mbButtonSize='SMALL' mbButtonAvailableStyle='PRIMARY'
                mbButtonText="{{'selfService.label.add' | translate}}" (click)="createRequest()"></mb-button>
      </div>
    </div>
  </form>
  </div>

<div class="search__content--group content__item content__item--border app-list">
  <mb-table-wrap>
    <mb-table (changePageNum)='doSearch($event)' [tableConfig]='tableConfig' [tableData]='searchResult'></mb-table>
  </mb-table-wrap>
</div>

<ng-template #statusTmpl let-status='status'>
  <nz-tag [nzColor]="TAG.STATUS_DRAFT" *ngIf='status === REQUEST_STATUS.DRAFT || !status'>{{ getStatus(status ?? 0)}}</nz-tag>
  <nz-tag [nzColor]="TAG.STATUS_WAIT_APPROVE" *ngIf='status === REQUEST_STATUS.WAIT_APPROVE'>{{ getStatus(status) }}</nz-tag>
  <nz-tag [nzColor]="TAG.STATUS_APPROVED" *ngIf='status === REQUEST_STATUS.APPROVED'>{{ getStatus(status) }}</nz-tag>
  <nz-tag [nzColor]="TAG.STATUS_REJECT" *ngIf='status === REQUEST_STATUS.REJECT'>{{ getStatus(status) }}</nz-tag>
  <nz-tag [nzColor]="TAG.STATUS_REQUEST_CANCEL" *ngIf='status === REQUEST_STATUS.REQUEST_CANCEL'>{{ getStatus(status) }}</nz-tag>
  <nz-tag [nzColor]="TAG.STATUS_CANCEL" *ngIf='status === REQUEST_STATUS.CANCEL'>{{ getStatus(status) }}</nz-tag>
  <nz-tag [nzColor]="TAG.STATUS_AJUST" *ngIf='status === REQUEST_STATUS.AJUST'>{{ getStatus(status) }}</nz-tag>
  <nz-tag [nzColor]="TAG.WAIT_APPROVE_BACKDATE" *ngIf='status === REQUEST_STATUS.BACK_DATE'>{{ getStatus(status) }}</nz-tag>
  <nz-tag [nzColor]="TAG.WAIT_APPROVE_BACKDATE" *ngIf='status === REQUEST_STATUS.CANCEL_BACKDATE'>{{ getStatus(status) }}</nz-tag>
</ng-template>

<!--<ng-template #reasonTmpl let-reasonCode='reasonCode'>-->
<!--  {{ getReasonLabel(reasonCode) }}-->
<!--</ng-template>-->
<!-- Thời gian nghỉ -->
<ng-template #timeLeaveTmpl let-listAbsRequestLeavesText='listAbsRequestLeavesText'>
  <ng-container *ngIf="listAbsRequestLeavesText">
    <ul class="leave-time">
      <li *ngFor="let item of listAbsRequestLeavesText">{{item}}</li>
    </ul>
  </ng-container>
</ng-template>
<!-- Người xét duyệt -->
<ng-template #reviewersTmpl let-listReviewer='listReviewer'>
  <ng-container *ngIf="listReviewer">
    <div *ngFor="let item of listReviewer">
      <ng-container [ngTemplateOutlet]="statusTemplate" [ngTemplateOutletContext]="item"></ng-container>
      {{item.fullName}}
    </div>
  </ng-container>
</ng-template>
<!-- Người phê duyệt -->
<ng-template #approversTmpl let-listApprover='listApprover'>
  <ng-container *ngIf="listApprover">
    <div *ngFor="let item of listApprover">
      <ng-container [ngTemplateOutlet]="statusTemplate" [ngTemplateOutletContext]="item"></ng-container>
      {{item.fullName}}
    </div>
  </ng-container>
</ng-template>

<!-- template action -->
<ng-template #actionTmpl let-status='status' let-requestId='requestId'>
  <em nz-icon
       class="menu__item--btn"
       nz-button
       nzType="more"
       nzTheme="outline"
       nzTrigger="click"
       nz-dropdown
       [nzDropdownMenu]="menu"
       [nzClickHide]="false"
    ></em>
  <nz-dropdown-menu #menu="nzDropdownMenu">
    <ul nz-menu>
      <!-- Điều chỉnh -->
      <li *ngIf="status === REQUEST_STATUS.APPROVED" nz-menu-item nz-button (click)="actionAjust(requestId)">
        {{'selfService.table.action.ajust' | translate}}
      </li>
      <!-- Hủy -->
      <li *ngIf="showActionCancel(status)" nz-menu-item nz-button nz-popconfirm
        nzPopconfirmTitle="{{'selfService.table.action.confirmCancel' | translate}}"
        nzCancelText="{{'selfService.table.action.cancel2' | translate}}" nzOkType="primary"
        nzOkText="{{'selfService.table.action.yes' | translate}}" (nzOnConfirm)="actionCancel(requestId)">
        {{'selfService.table.action.cancelRequest' | translate}}
      </li>
      <!-- Cập nhật -->
      <li *ngIf="status === REQUEST_STATUS.DRAFT" nz-menu-item nz-button (click)="onUpdate(requestId)">
        {{'selfService.table.action.edit' | translate}}
      </li>
      <!-- Gửi duyệt -->
      <li *ngIf="status === REQUEST_STATUS.DRAFT" nz-button nz-menu-item nz-popconfirm
        nzPopconfirmTitle="{{'selfService.table.action.confirmSubmit' | translate}}"
        nzCancelText="{{'selfService.table.action.cancel2' | translate}}" nzOkType="primary"
        nzOkText="{{'selfService.table.action.yes' | translate}}"
        (nzOnConfirm)="submitRequest(requestId)">
        {{'selfService.table.action.submit' | translate}}
      </li>
      <!-- Xóa -->
      <li *ngIf="status === REQUEST_STATUS.DRAFT" nz-button nz-menu-item nz-popconfirm
        nzPopconfirmTitle="{{'selfService.table.action.confirmDelete' | translate}}"
        nzCancelText="{{'selfService.table.action.cancel2' | translate}}" nzOkType="primary"
        nzOkText="{{'selfService.table.action.yes' | translate}}" [nzDanger]='true'
        (nzOnConfirm)="deleteItem(requestId)">
        {{'selfService.table.action.delete' | translate}}
      </li>
      <!-- Xem chi tiết -->
      <li nz-menu-item nz-button (click)="actionViewDetail(requestId)">
        {{'selfService.table.action.viewDetail' | translate}}
      </li>
    </ul>
  </nz-dropdown-menu>
</ng-template>

<!--Thông tin ngày nghỉ trong năm-->
<nz-modal [(nzVisible)]="isModalLeaveShow" (nzOnCancel)="onCancelLeaveDetailModal()">
  <ng-container *nzModalTitle>
    <div>
      <h4 [ngStyle]="{marginBottom: '0'}">{{'selfService.label.infoLeaveInYear' | translate}}</h4>
    </div>
    <div [ngStyle]="{marginRight: '30px'}">
      <nz-date-picker nzMode="year" [(ngModel)]="yearSelect" (ngModelChange)="onYearChange($event)"></nz-date-picker>
    </div>
  </ng-container>
  <ng-container *nzModalContent>
    <nz-table #basicTable [nzData]="listDayLeaveInYear" [nzShowPagination]="false">
      <thead>
      <tr>
        <th scope="col" [nzAlign]="'center'">{{'selfService.table.infoLeaveInYear.stt' | translate}}</th>
        <th scope="col">{{'selfService.table.infoLeaveInYear.leaveType' | translate}}</th>
        <th scope="col">{{'selfService.table.infoLeaveInYear.numberDay' | translate}}</th>
      </tr>
      </thead>
      <tbody>
      <tr *ngFor="let data of basicTable.data; let i = index">
        <td [nzAlign]="'center'">{{i + 1}}</td>
        <td>{{data.title}}</td>
        <td>{{data.content}}</td>
      </tr>
      </tbody>
    </nz-table>
  </ng-container>
  <ng-container *nzModalFooter>
    <mb-button mbButtonText="{{'selfService.table.action.close' | translate}}" (click)="onCancelLeaveDetailModal()"></mb-button>
  </ng-container>
</nz-modal>

<ng-template #statusTemplate let-status="status">
  <span *ngIf="status === 1" class="far fa-clock ic-wait-approve" nz-tooltip [nzTooltipTitle]="'selfService.table.statusType.waitApprove' | translate"></span>
  <span *ngIf="status === 2" class="far fa-check ic-approved" nz-tooltip [nzTooltipTitle]="'selfService.table.statusType.approved' | translate"></span>
  <span *ngIf="status === 3" class="far fa-times ic-reject" nz-tooltip [nzTooltipTitle]="'selfService.table.statusType.reject' | translate"></span>
</ng-template>